"""Autogenerated file: DO NOT EDIT!"""
import typing  # noqa: F401
from dazzler.system import Component, Aspect, UNDEFINED  # noqa: F401


class Table(Component):
    """
    Display data in a tabular manner (Non interactive).

    :CSS:

        - ``dazzler-core-table``
        - ``table-head``
        - ``table-heading``
        - ``table-body``
        - ``table-row``
        - ``table-cell``
        - ``table-footer``

    :Example:

    .. literalinclude:: ../../tests/components/pages/table.py
        :lines: 5-22
    """
    _aspect_keys = []
    _children = []
    rows = Aspect(children=True, docstring="Rows of data or components to display.")  # noqa: E501
    caption = Aspect(children=True, docstring="Title of the table")
    headers = Aspect(children=True, docstring="Table headings")
    class_name = Aspect(docstring="CSS class of the table.")
    style = Aspect(docstring="Style of the table element.")
    footer = Aspect(children=True, docstring="Content of tfoot element (.table-footer)")  # noqa: E501
    include_row_number = Aspect(docstring="Each row start with the row number.")  # noqa: E501
    row_number_start = Aspect(docstring="The start of the row number, useful if paged.")  # noqa: E501
    default_table = Aspect(default=True, docstring="Apply default style. (default=True)")  # noqa: E501
    collapsed = Aspect(default=True, docstring="Collapse the borders of the table. (default=True)")  # noqa: E501
    centered = Aspect(docstring="Center the cell")
    bordered = Aspect(docstring="Put a border around elements")
    size = Aspect(docstring="The size of the table. (Possible values: 'tiny', 'small', 'medium', 'large', 'larger', 'x-large', 'xx-large')")  # noqa: E501

    def __init__(
            self,
            rows: typing.Optional[typing.List[typing.List[typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]]]] = UNDEFINED,  # noqa: E501
            caption: typing.Optional[typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]] = UNDEFINED,  # noqa: E501
            headers: typing.Optional[typing.List[typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]]] = UNDEFINED,  # noqa: E501
            class_name: typing.Optional[str] = UNDEFINED,
            style: typing.Optional[typing.Dict] = UNDEFINED,
            footer: typing.Optional[typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]] = UNDEFINED,  # noqa: E501
            include_row_number: typing.Optional[bool] = UNDEFINED,
            row_number_start: typing.Optional[typing.Union[float, int]] = UNDEFINED,  # noqa: E501
            default_table: typing.Optional[bool] = True,
            collapsed: typing.Optional[bool] = True,
            centered: typing.Optional[bool] = UNDEFINED,
            bordered: typing.Optional[bool] = UNDEFINED,
            size: typing.Optional[typing.Any] = UNDEFINED,
            identity: str = None
    ):
        """
        :param rows: Rows of data or components to display.
        :param caption: Title of the table
        :param headers: Table headings
        :param class_name: CSS class of the table.
        :param style: Style of the table element.
        :param footer: Content of tfoot element (.table-footer)
        :param include_row_number: Each row start with the row number.
        :param row_number_start: The start of the row number, useful if
            paged.
        :param default_table: Apply default style. (default=True)
        :param collapsed: Collapse the borders of the table. (default=True)
        :param centered: Center the cell
        :param bordered: Put a border around elements
        :param size: The size of the table. (Possible values: 'tiny',
            'small', 'medium', 'large', 'larger', 'x-large', 'xx-large')
        """
        Component.__init__(self, locals(), identity)
